//+------------------------------------------------------------------+
//|                        Digital Low Pass (FATL/SATL, KGLP) Filter |
//|                      Copyright (c) Sergey Iljukhin, Novosibirsk. |
//|                        mailto:sergey@tibet.ru  http://fx.qrz.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2005, Sergey Iljukhin, Novosibirsk"
#property link      "mailto:sergey@tibet.ru"

/*

     MetaTrader 4.
 
  !      DLL 
      - bdsp.dll, lapack.dll, mkl_support.dll,
       C:\Windows\System32\    DF.dll  \experts\libraries\
 
    :
  
  1.    "Allow DLL import"  "Confirm DLL function's call"   Options->Expert Advisors
  2.    C:\Windows\System32\  Bdsp.dll, lapack.dll, mkl_support.dll -   . 
 
    :
  
  Ftype -  : 0 -  (FATL/SATL/KGLP), 1 -  (KGHP), 
          2 -  (RBCI/KGBP), 3 -  (KGBS)
  P1 -      P1, 
  D1 -        D1, 
  A1 -        1, 
  P2 -      P2, 
  D2 -        D2, 
  A2 -        2, 
  Ripple -    , 
  Delay - , 

        P2,D2,A2 
   :
  : P1>D1
  : P1<D1
    : D2>P2>P1>D1

*/

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1   DeepSkyBlue
#property indicator_color2   PaleVioletRed
#property indicator_color3   PaleVioletRed
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2

#import "DF.dll"
 int DigitalFilter(int FType, int P1, int D1, int A1, int P2, int D2, int A2,
                   double Ripple, int Delay, double& arr[]); 

//   
extern string TimeFrame="Current time frame";
extern int FType=2;
extern int P1=25;
extern int D1=21;
extern int A1=40;
extern int P2=33;
extern int D2=37;
extern int A2=40;
extern int Delay=0;
extern double Ripple=0.08; 
extern int BarShift=0; //  , .  - ,  - 
extern bool alertsOn         = false;
extern bool alertsOnCurrent  = false;
extern bool alertsMessage    = true;
extern bool alertsSound      = false;
extern bool alertsEmail      = false;
extern bool Interpolate=true;

//---- buffers
int FilterSize=1;
double FilterResponse[], FilterBuffer[1500];
double FilterResponseDa[];
double FilterResponseDb[];
double Trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,FilterResponse);
   SetIndexBuffer(1,FilterResponseDa);
   SetIndexBuffer(2,FilterResponseDb);
   SetIndexBuffer(3,Trend);
   
   //
   //
   //
   //
   //

      timeFrame = stringToTimeFrame(TimeFrame);
      if (timeFrame==Period())
      {
         FilterSize=0;
         if(IsDllsAllowed()!=false)
         {
            FilterSize=DigitalFilter(FType, P1, D1, A1, P2, D2, A2, Ripple, Delay, FilterBuffer); 
            if (FilterSize>0)
            {
                  SetIndexDrawBegin(0,FilterSize);
                  SetIndexDrawBegin(1,FilterSize);
                  SetIndexDrawBegin(2,FilterSize);
            }                  
            else Print("Incorrect input parameters. Indicator cannot run.");
         }  else Print("Library call is not allowed. Indicator cannot run.");
      }
      else
      {
         SetIndexDrawBegin(0,0);
         SetIndexDrawBegin(1,0);
         SetIndexDrawBegin(2,0);
      }
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      

   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+" digital filter");
   return(0);
}

//+------------------------------------------------------------------
//| 
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (IsDllsAllowed()==false) return(0);
   if (FilterSize<=0)          return(0);
   if (Bars<=FilterSize)       return(0);

   int limit,counted_bars = IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { FilterResponse[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
      if (calculateValue || timeFrame == Period())
      {
         if (Trend[limit] == -1) CleanPoint(limit-BarShift,FilterResponseDa,FilterResponseDb);
         for(int i = limit; i >= 0; i--)
         {
            Trend[i]  = Trend[i+1];
            FilterResponseDa[i-BarShift]=EMPTY_VALUE;
            FilterResponseDb[i-BarShift]=EMPTY_VALUE;
            FilterResponse[i-BarShift]  =0;
               
               for (int j=0; j<FilterSize; j++) FilterResponse[i-BarShift]=FilterResponse[i-BarShift]+FilterBuffer[j]*Close[i+j];
               
            if (FilterResponse[i-BarShift]>FilterResponse[i-BarShift+1]) Trend[i] =  1;
            if (FilterResponse[i-BarShift]<FilterResponse[i-BarShift+1]) Trend[i] = -1;
            if (Trend[i] == -1) PlotPoint(i-BarShift,FilterResponseDa,FilterResponseDb,FilterResponse);
         }
         manageAlerts();         
         return(0);
      }
   
   //
   //
   //
   //
   //

      limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (Trend[limit]==-1) CleanPoint(limit,FilterResponseDa,FilterResponseDb);
      for (i=limit;i>=0;i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            FilterResponse[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FType,P1,D1,A1,P2,D2,A2,Delay,Ripple,BarShift,0,y);
            Trend[i]          = Trend[i+1];
            if (FilterResponse[i]>FilterResponse[i+1]) Trend[i] =  1;
            if (FilterResponse[i]<FilterResponse[i+1]) Trend[i] = -1;

            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
                  FilterResponse[i+k] = FilterResponse[i] + (FilterResponse[i+n]-FilterResponse[i])*k/n;
      }
      for (i=limit;i>=0;i--) if (Trend[i] == -1) PlotPoint(i,FilterResponseDa,FilterResponseDb,FilterResponse);
      
   //
   //
   //
   //
   //

   manageAlerts();         
   return(0);   
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (Trend[whichBar] != Trend[whichBar+1])
      {
         if (Trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (Trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",timeFrameToString(timeFrame)+" digital filters slope changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"digital filters "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

